/* $Header:   F:/source/cwright/cwstart/asm.c_v   1.30   26 Jul 1993 10:16:42   ericj  $ */
/*
 *
 *                Copyright 1991,1992,1993 Premia Corp.
 *                        All rights reserved
 *
 *    This source code is provided to the purchaser of the product
 *    for the purpose of allowing the purchaser to customize and/or
 *    extend the functionality of the product.  The source code   
 *    remains the property of Premia Corp. with all rights reserved.
 *    Any modifications to the source code are considered derivative
 *    works and all rights thereto are reserved to Premia Corp. except
 *    that the purchaser may use the modified product in the same
 *    permitted manner as the unmodified product.  It is expressly
 *    prohibited to distribute in any manner any part of the original
 *    source code, whether in source or object form, without the
 *    express written permission from Premia Corp.
 *
 *    Owner:
 *        Premia Corporation
 *        1075 NW Murray Blvd., Suite 268
 *        Portland OR 97229
 *
 *    Thanks to:
 *
 *    Marcelo Aguisky
 *    Software Engineer
 *    marcelo.aguisky@iname.com
 *
 *    for contributing this dll and source code.
 *
 */

#include <windows.h>
#include <string.h>
#include <ctype.h>
#include "exports.h"
#include "cwstart.h"

LIBMAIN    /* defines the LibMain() */


#define MAX_BUF_LEN    100
//**********************************************************************
/* ------------------------------------------------------------------ */
/* ASCII to US English EBCDIC Translation                             */
/* ------------------------------------------------------------------ */
/*                                                                    */
unsigned char ttANSI2English[256] =
{
/* EBCDIC hex    Index  char */
    0x3e,  /*    0   ;  no   */
    0x01,  /*    1   ;  no   */
    0x02,  /*    2   ;  no   */
    0x03,  /*    3   ;  no   */
    0x37,  /*    4   ;  no   */
    0x2d,  /*    5   ;  no   */
    0x2e,  /*    6   ;  no   */
    0x2f,  /*    7   ;  no   */
    0x16,  /*    8   ;  no   */
    0x05,  /*    9   ;  no   */
    0x0A,  /*   10   ;  no   */
    0x0b,  /*   11   ;  no   */
    0x0c,  /*   12   ;  no   */
    0x0d,  /*   13   ;  no   */
    0x0e,  /*   14   ;  no   */
    0x0f,  /*   15   ;  no   */
    0x10,  /*   16   ;  no   */
    0x11,  /*   17   ;  no   */
    0x12,  /*   18   ;  no   */
    0x13,  /*   19   ;  no   */
    0x3c,  /*   20   ;  no   */
    0x3d,  /*   21   ;  no   */
    0x32,  /*   22   ;  no   */
    0x26,  /*   23   ;  no   */
    0x18,  /*   24   ;  no   */
    0x19,  /*   25   ;  no   */
    0x3f,  /*   26   ;  no   */
    0x27,  /*   27   ;  no   */
    0x1c,  /*   28   ;  no   */
    0x1d,  /*   29   ;  no   */
    0x1e,  /*   30   ;  no   */
    0x1f,  /*   31   ;  no   */
    0x40,  /*   32   ; blank */
    0x5a,  /*   33   ;  !    */
    0x7f,  /*   34   ;  "    */
    0x7b,  /*   35   ;  #    */
    0x5b,  /*   36   ;  $    */
    0x6c,  /*   37   ;  %    */
    0x50,  /*   38   ;  &    */
    0x7d,  /*   39   ;  '    */
    0x4d,  /*   40   ;  (    */
    0x5d,  /*   41   ;  )    */
    0x5c,  /*   42   ;  *    */
    0x4e,  /*   43   ;  +    */
    0x6b,  /*   44   ;  ,    */
    0x60,  /*   45   ;  -    */
    0x4b,  /*   46   ;  .    */
    0x61,  /*   47   ;  /    */
    0xf0,  /*   48   ;  0    */
    0xf1,  /*   49   ;  1    */
    0xf2,  /*   50   ;  2    */
    0xf3,  /*   51   ;  3    */
    0xf4,  /*   52   ;  4    */
    0xf5,  /*   53   ;  5    */
    0xf6,  /*   54   ;  6    */
    0xf7,  /*   55   ;  7    */
    0xf8,  /*   56   ;  8    */
    0xf9,  /*   57   ;  9    */
    0x7a,  /*   58   ;  :    */
    0x5e,  /*   59   ;  ;    */
    0x4c,  /*   60   ;  <    */
    0x7e,  /*   61   ;  =    */
    0x6e,  /*   62   ;  >    */
    0x6f,  /*   63   ;  ?    */
    0x7c,  /*   64   ;  @    */
    0xc1,  /*   65   ;  A    */
    0xc2,  /*   66   ;  B    */
    0xc3,  /*   67   ;  C    */
    0xc4,  /*   68   ;  D    */
    0xc5,  /*   69   ;  E    */
    0xc6,  /*   70   ;  F    */
    0xc7,  /*   71   ;  G    */
    0xc8,  /*   72   ;  H    */
    0xc9,  /*   73   ;  I    */
    0xd1,  /*   74   ;  J    */
    0xd2,  /*   75   ;  K    */
    0xd3,  /*   76   ;  L    */
    0xd4,  /*   77   ;  M    */
    0xd5,  /*   78   ;  N    */
    0xd6,  /*   79   ;  O    */
    0xd7,  /*   80   ;  P    */
    0xd8,  /*   81   ;  Q    */
    0xd9,  /*   82   ;  R    */
    0xe2,  /*   83   ;  S    */
    0xe3,  /*   84   ;  T    */
    0xe4,  /*   85   ;  U    */
    0xe5,  /*   86   ;  V    */
    0xe6,  /*   87   ;  W    */
    0xe7,  /*   88   ;  X    */
    0xe8,  /*   89   ;  Y    */
    0xe9,  /*   90   ;  Z    */
    0xba,  /*   91   ;  [    */
    0xe0,  /*   92   ;  \    */
    0xbb,  /*   93   ;  ]    */
    0xb0,  /*   94   ;  ^    */
    0x6d,  /*   95   ;  _    */
    0x79,  /*   96   ;  `    */
    0x81,  /*   97   ;  a    */
    0x82,  /*   98   ;  b    */
    0x83,  /*   99   ;  c    */
    0x84,  /*   100  ;  d    */
    0x85,  /*   101  ;  e    */
    0x86,  /*   102  ;  f    */
    0x87,  /*   103  ;  g    */
    0x88,  /*   104  ;  h    */
    0x89,  /*   105  ;  i    */
    0x91,  /*   106  ;  j    */
    0x92,  /*   107  ;  k    */
    0x93,  /*   108  ;  l    */
    0x94,  /*   109  ;  m    */
    0x95,  /*   110  ;  n    */
    0x96,  /*   111  ;  o    */
    0x97,  /*   112  ;  p    */
    0x98,  /*   113  ;  q    */
    0x99,  /*   114  ;  r    */
    0xa2,  /*   115  ;  s    */
    0xa3,  /*   116  ;  t    */
    0xa4,  /*   117  ;  u    */
    0xa5,  /*   118  ;  v    */
    0xa6,  /*   119  ;  w    */
    0xa7,  /*   120  ;  x    */
    0xa8,  /*   121  ;  y    */
    0xa9,  /*   122  ;  z    */
    0xc0,  /*   123  ;  {    */
    0x4f,  /*   124  ;  |    */
    0xd0,  /*   125  ;  }    */
    0xa1,  /*   126  ;  ~    */
    0x07,  /*   127  ;  no   */
    0x9f,  /*   128  ;  euro */
    0x21,  /*   129  ;  no   */
    0x9d,  /*   130  ;  ,    */
    0x23,  /*   131  ;  no   */
    0x24,  /*   132  ;  no   */
    0x15,  /*   133  ;  no   */
    0x06,  /*   134  ;  no   */
    0x17,  /*   135  ;  no   */
    0x28,  /*   136  ;  no   */
    0x29,  /*   137  ;  no   */
    0x2a,  /*   138  ;  no   */
    0x2b,  /*   139  ;  no   */
    0x2c,  /*   140  ;  no   */
    0x09,  /*   141  ;  no   */
    0x25,  /*   142  ;  no   */
    0x1b,  /*   143  ;  no   */
    0x30,  /*   144  ;  no   */
    0x31,  /*   145  ;  no   */
    0x1a,  /*   146  ;  no   */
    0x33,  /*   147  ;  no   */
    0x34,  /*   148  ;  no   */
    0x35,  /*   149  ;  no   */
    0xff,  /*   150  ;      */
    0x08,  /*   151  ;  no   */
    0x38,  /*   152  ;  no   */
    0x39,  /*   153  ;  no   */
    0x3a,  /*   154  ;  no   */
    0x3b,  /*   155  ;  no   */
    0x04,  /*   156  ;  no   */
    0x14,  /*   157  ;  no   */
    0x00,  /*   158  ;  no   */
    0x22,  /*   159  ;  no   */
    0x36,  /*   160  ;  no   */
    0xaa,  /*   161  ;  no   */
    0x4a,  /*   162  ;  no   */
    0xb1,  /*   163  ;  no   */
    0x20,  /*   164  ;  no   */
    0xb2,  /*   165  ;  no   */
    0x6a,  /*   166  ;      */
    0xb5,  /*   167  ;  no   */
    0xbd,  /*   168  ;  no   */
    0xb4,  /*   169  ;  no   */
    0x9a,  /*   170  ;      */
    0x8a,  /*   171  ;  no   */
    0x5f,  /*   172  ;  no   */
    0xca,  /*   173  ;  shy  */
    0xaf,  /*   174  ;  no   */
    0xbc,  /*   175  ;  no   */
    0x90,  /*   176  ;  no   */
    0x8f,  /*   177  ;  no   */
    0xea,  /*   178  ;  no   */
    0xfa,  /*   179  ;  no   */
    0xbe,  /*   180  ;  no   */
    0xa0,  /*   181  ;  no   */
    0xb6,  /*   182  ;  no   */
    0xb3,  /*   183  ;  no   */
    0x41,  /*   184  ;  no   */
    0xda,  /*   185  ;  no   */
    0x9b,  /*   186  ;  no   */
    0x8b,  /*   187  ;  no   */
    0xb7,  /*   188  ;  no   */
    0xb8,  /*   189  ;  no   */
    0xb9,  /*   190  ;  no   */
    0xab,  /*   191  ;  no   */
    0x64,  /*   192  ;  no   */
    0x65,  /*   193  ;  no   */
    0x62,  /*   194  ;  no   */
    0x66,  /*   195  ;  no   */
    0x63,  /*   196  ;      */
    0x67,  /*   197  ;      */
    0x9e,  /*   198  ;  no   */
    0x68,  /*   199  ;  no   */
    0x74,  /*   200  ;  no   */
    0x71,  /*   201  ;  no   */
    0x72,  /*   202  ;  no   */
    0x73,  /*   203  ;  no   */
    0x78,  /*   204  ;  no   */
    0x75,  /*   205  ;  no   */
    0x76,  /*   206  ;  no   */
    0x77,  /*   207  ;  no   */
    0xac,  /*   208  ;  no   */
    0x69,  /*   209  ;  no   */
    0xed,  /*   210  ;  no   */
    0xee,  /*   211  ;  no   */
    0xeb,  /*   212  ;  no   */
    0xef,  /*   213  ;  no   */
    0xec,  /*   214  ;  no   */
    0xbf,  /*   215  ;  no   */
    0x80,  /*   216  ;  no   */
    0xfd,  /*   217  ;  no   */
    0xfe,  /*   218  ;  no   */
    0xfb,  /*   219  ;  no   */
    0xfc,  /*   220  ;  no   */
    0xad,  /*   221  ;  no   */
    0xae,  /*   222  ;  no   */
    0x59,  /*   223  ;  no   */
    0x44,  /*   224  ;  no   */
    0x45,  /*   225  ;  no   */
    0x42,  /*   226  ;  no   */
    0x46,  /*   227  ;  no   */
    0x43,  /*   228  ;  no   */
    0x47,  /*   229  ;  no   */
    0x9c,  /*   230  ;  no   */
    0x48,  /*   231  ;  no   */
    0x54,  /*   232  ;  no   */
    0x51,  /*   233  ;  no   */
    0x52,  /*   234  ;  no   */
    0x53,  /*   235  ;  no   */
    0x58,  /*   236  ;  no   */
    0x55,  /*   237  ;  no   */
    0x56,  /*   238  ;  no   */
    0x57,  /*   239  ;  no   */
    0x8c,  /*   240  ;  no   */
    0x49,  /*   241  ;  no   */
    0xcd,  /*   242  ;  no   */
    0xce,  /*   243  ;  no   */
    0xcb,  /*   244  ;  no   */
    0xcf,  /*   245  ;  no   */
    0xcc,  /*   246  ;  no   */
    0xe1,  /*   247  ;  no   */
    0x70,  /*   248  ;  no   */
    0xdd,  /*   249  ;  no   */
    0xde,  /*   250  ;  no   */
    0xdb,  /*   251  ;  no   */
    0xdc,  /*   252  ;  no   */
    0x8d,  /*   253  ;  no   */
    0x8e,  /*   254  ;  no   */
    0xdf   /*   255  ;  no   */
};


//**********************************************************************
/* ------------------------------------------------------------------ */
/* US English EBCDIC to ASCII Translation                             */
/* ------------------------------------------------------------------ */
/*                                                                    */
unsigned char ttEnglish2ANSI[256] =
{
/*                      ANSI */
/* ASCII hex     Index  char */
    0x9e,  /*    0   ;  no   */
    0x01,  /*    1   ;  no   */
    0x02,  /*    2   ;  no   */
    0x03,  /*    3   ;  no   */
    0x9C,  /*    4   ;      */
    0x09,  /*    5   ;  no   */
    0x86,  /*    6   ;      */
    0x7F,  /*    7   ;  no   */
    0x97,  /*    8   ;      */
    0x8D,  /*    9   ;  no   */
    0x0A,  /*   10   ;  no   */
    0x0B,  /*   11   ;  no   */
    0x0C,  /*   12   ;  no   */
    0x0D,  /*   13   ;  no   */
    0x0E,  /*   14   ;  no   */
    0x0F,  /*   15   ;  no   */
    0x10,  /*   16   ;  no   */
    0x11,  /*   17   ;  no   */
    0x12,  /*   18   ;  no   */
    0x13,  /*   19   ;  no   */
    0x9D,  /*   20   ;  no   */
    0x85,  /*   21   ;      */
    0x08,  /*   22   ;  no   */
    0x87,  /*   23   ;      */
    0x18,  /*   24   ;  no   */
    0x19,  /*   25   ;  no   */
    0x92,  /*   26   ;  '    */
    0x8F,  /*   27   ;  no   */
    0x1C,  /*   28   ;  no   */
    0x1D,  /*   29   ;  no   */
    0x1E,  /*   30   ;  no   */
    0x1F,  /*   31   ;  no   */
    0xa4,  /*   32   ;  no   */
    0x81,  /*   33   ;  no   */
    0x9f,  /*   34   ;      */
    0x83,  /*   35   ;      */
    0x84,  /*   36   ;      */
    0x8E,  /*   37   ;  no   */
    0x17,  /*   38   ;  no   */
    0x1B,  /*   39   ;  no   */
    0x88,  /*   40   ;      */
    0x89,  /*   41   ;      */
    0x8a,  /*   42   ;      */
    0x8b,  /*   43   ;      */
    0x8c,  /*   44   ;      */
    0x05,  /*   45   ;  no   */
    0x06,  /*   46   ;  no   */
    0x07,  /*   47   ;  no   */
    0x90,  /*   48   ;  no   */
    0x91,  /*   49   ;  '    */
    0x16,  /*   50   ;  no   */
    0x93,  /*   51   ;  "    */
    0x94,  /*   52   ;  "    */
    0x95,  /*   53   ;      */
    0xa0,  /*   54   ;  no   */
    0x04,  /*   55   ;  no   */
    0x98,  /*   56   ;      */
    0x99,  /*   57   ;      */
    0x9A,  /*   58   ;      */
    0x9B,  /*   59   ;      */
    0x14,  /*   60   ;  no   */
    0x15,  /*   61   ;  no   */
    0x00,  /*   62   ;  no   */
    0x1A,  /*   63   ;  no   */
    0x20,  /*   64   ; blank */
    0xb8,  /*   65   ;      */
    0xe2,  /*   66   ;      */
    0xe4,  /*   67   ;      */
    0xe0,  /*   68   ;      */
    0xe1,  /*   69   ;      */
    0xe3,  /*   70   ;      */
    0xe5,  /*   71   ;      */
    0xe7,  /*   72   ;      */
    0xf1,  /*   73   ;      */
    0xa2,  /*   74   ;      */
    0x2e,  /*   75   ;  .    */
    0x3c,  /*   76   ;  <    */
    0x28,  /*   77   ;  (    */
    0x2b,  /*   78   ;  +    */
    0x7c,  /*   79   ;  |    */
    0x26,  /*   80   ;  &    */
    0xe9,  /*   81   ;      */
    0xea,  /*   82   ;      */
    0xeb,  /*   83   ;      */
    0xe8,  /*   84   ;      */
    0xed,  /*   85   ;      */
    0xee,  /*   86   ;      */
    0xef,  /*   87   ;      */
    0xec,  /*   88   ;      */
    0xdf,  /*   89   ;      */
    0x21,  /*   90   ;  !    */
    0x24,  /*   91   ;  $    */
    0x2a,  /*   92   ;  *    */
    0x29,  /*   93   ;  )    */
    0x3b,  /*   94   ;  ;    */
    0xac,  /*   95   ;      */  /*original 0x20*/
    0x2d,  /*   96   ;  -    */
    0x2f,  /*   97   ;  /    */
    0xc2,  /*   98   ;      */
    0xc4,  /*   99   ;      */
    0xc0,  /*   100  ;      */
    0xc1,  /*   101  ;      */
    0xc3,  /*   102  ;      */
    0xc5,  /*   103  ;      */
    0xc7,  /*   104  ;      */
    0xd1,  /*   105  ;      */
    0xa6,  /*   106  ;      */
    0x2c,  /*   107  ;  , comma */
    0x25,  /*   108  ;  %    */
    0x5f,  /*   109  ;  _    */
    0x3e,  /*   110  ;  >    */
    0x3f,  /*   111  ;  ?    */
    0xf8,  /*   112  ;      */
    0xc9,  /*   113  ;      */
    0xca,  /*   114  ;      */
    0xcb,  /*   115  ;      */
    0xc8,  /*   116  ;      */
    0xcd,  /*   117  ;      */
    0xce,  /*   118  ;      */
    0xcf,  /*   119  ;      */
    0xcc,  /*   120  ;      */
    0x60,  /*   121  ;  `    */
    0x3a,  /*   122  ;  :    */
    0x23,  /*   123  ;  #    */
    0x40,  /*   124  ;  @    */
    0x27,  /*   125  ;  '    */
    0x3d,  /*   126  ;  =    */
    0x22,  /*   127  ;  "    */
    0xd8,  /*   128  ;      */
    0x61,  /*   129  ;  a    */
    0x62,  /*   130  ;  b    */
    0x63,  /*   131  ;  c    */
    0x64,  /*   132  ;  d    */
    0x65,  /*   133  ;  e    */
    0x66,  /*   134  ;  f    */
    0x67,  /*   135  ;  g    */
    0x68,  /*   136  ;  h    */
    0x69,  /*   137  ;  i    */
    0xab,  /*   138  ;      */
    0xbb,  /*   139  ;      */
    0xf0,  /*   140  ;      */
    0xfd,  /*   141  ;      */
    0xfe,  /*   142  ;      */
    0xb1,  /*   143  ;      */
    0xb0,  /*   144  ;      */
    0x6a,  /*   145  ;  j    */
    0x6b,  /*   146  ;  k    */
    0x6c,  /*   147  ;  l    */
    0x6d,  /*   148  ;  m    */
    0x6e,  /*   149  ;  n    */
    0x6f,  /*   150  ;  o    */
    0x70,  /*   151  ;  p    */
    0x71,  /*   152  ;  q    */
    0x72,  /*   153  ;  r    */
    0xaa,  /*   154  ;      */
    0xba,  /*   155  ;      */
    0xe6,  /*   156  ;      */
    0x82,  /*   157  ;      */
    0xc6,  /*   158  ;      */
    0x80,  /*   159  ;  euro */
    0xb5,  /*   160  ;      */
    0x7e,  /*   161  ;  ~    */
    0x73,  /*   162  ;  s    */
    0x74,  /*   163  ;  t    */
    0x75,  /*   164  ;  u    */
    0x76,  /*   165  ;  v    */
    0x77,  /*   166  ;  w    */
    0x78,  /*   167  ;  x    */
    0x79,  /*   168  ;  y    */
    0x7a,  /*   169  ;  z    */
    0xa1,  /*   170  ;      */
    0xbf,  /*   171  ;      */
    0xd0,  /*   172  ;      */
    0xdd,  /*   173  ;      */
    0xde,  /*   174  ;      */
    0xae,  /*   175  ;      */
    0x5e,  /*   176  ;  ^    */
    0xa3,  /*   177  ;      */
    0xa5,  /*   178  ;      */
    0xb7,  /*   179  ;      */
    0xa9,  /*   180  ;      */
    0xa7,  /*   181  ;      */
    0xb6,  /*   182  ;      */
    0xbc,  /*   183  ;      */
    0xbd,  /*   184  ;      */
    0xbe,  /*   185  ;      */
    0x5b,  /*   186  ;  [    */
    0x5d,  /*   187  ;  ]    */
    0xaf,  /*   188  ;      */
    0xa8,  /*   189  ;      */
    0xb4,  /*   190  ;      */
    0xd7,  /*   191  ;      */
    0x7b,  /*   192  ;  {    */
    0x41,  /*   193  ;  A    */
    0x42,  /*   194  ;  B    */
    0x43,  /*   195  ;  C    */
    0x44,  /*   196  ;  D    */
    0x45,  /*   197  ;  E    */
    0x46,  /*   198  ;  F    */
    0x47,  /*   199  ;  G    */
    0x48,  /*   200  ;  H    */
    0x49,  /*   201  ;  I    */
    0xad,  /*   202  ;  -    */
    0xf4,  /*   203  ;      */
    0xf6,  /*   204  ;      */
    0xf2,  /*   205  ;      */
    0xf3,  /*   206  ;      */
    0xf5,  /*   207  ;      */
    0x7d,  /*   208  ;  }    */
    0x4a,  /*   209  ;  J    */
    0x4b,  /*   210  ;  K    */
    0x4c,  /*   211  ;  L    */
    0x4d,  /*   212  ;  M    */
    0x4e,  /*   213  ;  N    */
    0x4f,  /*   214  ;  O    */
    0x50,  /*   215  ;  P    */
    0x51,  /*   216  ;  Q    */
    0x52,  /*   217  ;  R    */
    0xb9,  /*   218  ;      */
    0xfb,  /*   219  ;      */
    0xfc,  /*   220  ;      */
    0xf9,  /*   221  ;      */
    0xfa,  /*   222  ;      */
    0xff,  /*   223  ;      */
    0x5c,  /*   224  ;  \    */
    0xf7,  /*   225  ;      */
    0x53,  /*   226  ;  S    */
    0x54,  /*   227  ;  T    */
    0x55,  /*   228  ;  U    */
    0x56,  /*   229  ;  V    */
    0x57,  /*   230  ;  W    */
    0x58,  /*   231  ;  X    */
    0x59,  /*   232  ;  Y    */
    0x5a,  /*   233  ;  Z    */
    0xb2,  /*   234  ;      */
    0xd4,  /*   235  ;      */
    0xd6,  /*   236  ;      */
    0xd2,  /*   237  ;      */
    0xd3,  /*   238  ;      */
    0xd5,  /*   239  ;      */
    0x30,  /*   240  ;  0    */
    0x31,  /*   241  ;  1    */
    0x32,  /*   242  ;  2    */
    0x33,  /*   243  ;  3    */
    0x34,  /*   244  ;  4    */
    0x35,  /*   245  ;  5    */
    0x36,  /*   246  ;  6    */
    0x37,  /*   247  ;  7    */
    0x38,  /*   248  ;  8    */
    0x39,  /*   249  ;  9    */
    0xb3,  /*   250  ;      */
    0xdb,  /*   251  ;      */
    0xdc,  /*   252  ;      */
    0xd9,  /*   253  ;      */
    0xda,  /*   254  ;      */
    0x96   /*   255  ;      */
};



int DLL CharASCIIToEBCDIC(int inChar);
int DLL CharEBCDICToASCII(int inChar);
void BufferASCIIToEBCDIC(void);
void BufferEBCDICToASCII(void);

void DLL _xxx_init( void );


void DLL 
_init()
{
    _xxx_init();
    
    /* This line causes .yyy files to be treated like .xxx files    */
    ExtAlias(".yyy", ".xxx");
}


/*
 ** _xxx_init()
 *
 *  Initialize this module by exported any required functions and
 *  the hash tables needed to support indenting, template expandion
 *  and keyword coloring.
 */
void DLL
_xxx_init( void )
{
    static BOOL firstTime = TRUE;

    if (firstTime)
    {
        /* _xxx language handling functions get called via LibFunctionExec,
         * so they must be exported.
         */
        LibExport( "int CharEBCDICToASCII int");
        LibExport( "int CharASCIIToEBCDIC int");
        LibExport( "BufferEBCDICToASCII");
        LibExport( "BufferASCIIToEBCDIC");
        firstTime = FALSE;
    }
}
// This is  an ASCII to  EBCDIC conversion.  

void BufferASCIIToEBCDIC(void)
{
int currChar = 0;
    _PosInit(0);
    currChar = _PosCurrentChar();
    do
    {

    _PosReplaceChar( ttANSI2English[currChar ]);  
    
    } while ((currChar = _PosNextChar()) != EOF_CHAR);
/////////////////////end of macro
}

// This is  an EBCDIC to  ASCII conversion

void  BufferEBCDICToASCII(void)
{
int currChar = 0;

    _PosInit(0);
    currChar = _PosCurrentChar();
    do
    {

       _PosReplaceChar( ttEnglish2ANSI[currChar ]);  

    } while ((currChar = _PosNextChar()) != EOF_CHAR);

}

int DLL 
CharEBCDICToASCII(int inChar)
{
   return ttEnglish2ANSI [(unsigned char)inChar];
}

int 
DLL CharASCIIToEBCDIC(int inChar)
{
   return ttANSI2English [(unsigned char)inChar];
}
